//
//      t[GCϊ FFT Library
//      coder : Ko-Ta
//
// Fixed Date
//
//      2003.01/19      gK֐ǉ
//      2003.01/17      Oap̊֐Ƃǉ𖳐ɂ
//      2003.01/15      n~OĂȂɁiR
//      2003.01/13      Ƃ肠Ă݂悤

unit FFTLib;

interface

uses Windows,Classes,math;

//==============================================================================
// DSP Class
type TFFT = class
  private
  protected
    SinTbl   : array of Single;
    BitRev   : array of Integer;
    HammingTbl   :array of Single;
    InvHammingTbl:array of Single;
    NormTbl  : array of Single; 
    Sample   : Integer;
    tre,tim  : array of Single;

    procedure   MakeSinTbl;
    procedure   MakeBitRev;
    procedure   SubFFT(decode:Boolean);
    procedure   SubFFTComplex(decode:Boolean);
    procedure   MakeHammingTbl;
    procedure   MakeNormalizeTbl;
  public
    re,im    : array of Single;
    //E
    constructor Create(n:Integer);
    destructor  Destroy; override;
    procedure   Init(n:Integer);
    //FFTϊ
    procedure   FFT;
    procedure   UnFFT;
    //
    procedure   FFTComplex;
    procedure   UnFFTComplex;
    //g̕ёւ
    procedure   SortFFT;
    procedure   UnSortFFT;
    //n~O
    procedure   HammingWindow;
    procedure   UnHammingWindow;
    //WAVEg`臒l
    procedure   SatSmallInt;
    //glɂȂ悤ɕ⊮WKp
    //1.0ڈɂȂ悤ɕ⊮
    procedure   NormalizeFFT;


    //DCT
    //procedure   DCT(n:integer); overload;
    //procedure   UnDCT(n:Integer); overload;

end;

implementation


{ TDSP }

//------------------------------------------------------------------------------
// 
constructor TFFT.Create(n:Integer);
begin
  inherited Create; //Ӗ`

  init(n);
end;

//------------------------------------------------------------------------------
// 
destructor TFFT.Destroy;
begin
  SetLength(re,0);
  SetLength(im,0);
  SetLength(tre,0);
  SetLength(tim,0);

  inherited;
end;

//------------------------------------------------------------------------------
// 
procedure TFFT.Init(n:Integer);
begin
  //W{
  Sample := n;
  //eϐ̒ݒ
  SetLength(re,n);
  SetLength(im,n);
  SetLength(tre,n);
  SetLength(tim,n);

  //ee[u
  MakeSinTbl;
  MakeBitRev;
  MakeHammingTbl;
  MakeNormalizeTbl;
end;

{
//------------------------------------------------------------------------------
// Single  DCT
procedure TDSP.DCT(n:Integer);
var
  i,j : Integer;
  ck  : Single;
  tmp : Single;
begin
  for i:=0 to n-1 do
  begin
    if (i = 0)then ck := 1.0/8.0
              else ck := 1.0/4.0;
    tmp := 0;
    for j:=0 to n-1 do
      tmp := tmp + Src[j] * cos( ((2.0*j+1.0)*i*3.14159265)/(2.0*n) ); 
    Dest[i] := tmp*ck;
  end;
end;

//------------------------------------------------------------------------------
// DCT  Single
procedure TDSP.UnDCT(n: Integer);
var
  i,j : Integer;
  tmp : Single;
begin
  for i:=0 to n-1 do
  begin
    tmp := 0;
    for j:=0 to n-1 do
      tmp := tmp + Src[j] * cos( ((2.0*i+1.0)*j*3.14159265)/(2.0*n) );
    Dest[i] := tmp;
  end;
end;
}
//------------------------------------------------------------------------------
// SinTable̍쐬
procedure TFFT.MakeSinTbl;
var
  co,si,dc,ds,t : Single;
  n2,n4,n8 : Integer;
  i,n : Integer;
begin
  n  := Sample;

  SetLength(SinTbl,n div 4 * 3);
  
  n2 := n div 2;
  n4 := n div 4;
  n8 := n div 8;

  t  := Sin(3.141592 / n);
  dc := 2 * t * t;
  ds := sqrt(dc * (2 - dc));
  t  := 2 * dc;
  SinTbl[n4] := 1.0;
  SinTbl[0]  := 0.0;
  co := 1.0;
  si := 0.0;

  for i:=1 to n8-1 do
  begin
    co := co - dc;
    dc := dc + t * co;

    si := si + ds;
    ds := ds - t * si;

    SinTbl[i]      := si;
    SinTbl[n4 - i] := co;
  end;

  if (n8 <> 0)then
    sintbl[n8] := sqrt(0.5);

  for i:=0 to n4-1 do
  begin
    SinTbl[n2 - i ] :=  sintbl[i];
    SinTbl[i  + n2] := -sintbl[i];
  end;
end;

//------------------------------------------------------------------------------
// rbg]\̍쐬
procedure TFFT.MakeBitRev;
var
  i,j,k,n : Integer;
  n2 : Integer;
begin
  n := Sample;

  SetLength(BitRev,n);

  i := 0;
  j := 0;
  n2:= n div 2;

  while(TRUE)do
  begin
    bitrev[i] := j;
    inc(i);
    if (i >= n)then break;

    k := n2;
    while (k <= j) do
    begin
      j := j - k;
      k := k div 2;
    end;
    j := j + k;
  end;
end;

//------------------------------------------------------------------------------
// Single  FFT
procedure TFFT.FFT;
begin
  SubFFT(TRUE);
end;

//------------------------------------------------------------------------------
// FFT  Single
procedure TFFT.UnFFT;
begin
  SubFFT(FALSE);
end;

//------------------------------------------------------------------------------
// FFT ϊ
// Fourierϊ (FFT) (Cooley--TukeỹASY).
// re[] , im[] . ʂ re[],im[] ɏ㏑.
// decode=TRUE Ȃtϊs.
procedure TFFT.SubFFT(decode:Boolean);
var
  si,co,dr,di,t : Single;
  i,j,k     : Integer;
  ik,h,d,k2 : Integer;
  n,n4      : Integer;
begin
  n := Sample;
  n4:= n div 4;

  // rbg]
  for i:=0 to n-1 do
  begin
    j := BitRev[i];
    if (i < j)then
    begin
      t := re[i]; re[i] := re[j]; re[j] := t;
      t := im[i]; im[i] := im[j]; im[j] := t;
    end;
  end;

  k := 1;
  while (k < n) do
  begin
    h  := 0;
    k2 := k + k;
    d := n div k2;

    for j:=0 to k-1 do
    begin
      co := SinTbl[h + n4];
      si := SinTbl[h];
      if (decode)then si := -si;

      i := j;
      while (i<n) do
      begin
        ik := i + k;
        dr := si * im[ik] + co * re[ik];
        di := co * im[ik] - si * re[ik];
        re[ik] := re[i] - dr; re[i] := re[i] + dr;
        im[ik] := im[i] - di; im[i] := im[i] + di;

        i := i + k2;
      end;

      h := h + d;
    end;

    k := k2;
  end;

  if (decode)then
  begin
    t := 1.0 / n;
    for i:=0 to n-1 do
    begin
      re[i] := re[i] * t;
      im[i] := im[i] * t;
    end;
  end;

end;

//------------------------------------------------------------------------------
// ֐̓Kp
procedure TFFT.HammingWindow;
var
  i : Integer;
  n : Integer;
begin
  n := Sample;
  for i:=0 to n-1 do
  begin
    re[i] := re[i] * HammingTbl[i];
    im[i] := im[i] * HammingTbl[i];
  end;
end;

//------------------------------------------------------------------------------
// ֐ɖ߂
procedure TFFT.UnHammingWindow;
var
  i : Integer;
  n : Integer;
begin
  n := Sample;
  for i:=0 to n-1 do
  begin
    re[i] := re[i] * InvHammingTbl[i];
    im[i] := im[i] * InvHammingTbl[i];
  end;
end;

//------------------------------------------------------------------------------
// ֐ HammingWindowTable̍쐬
procedure TFFT.MakeHammingTbl;
var
  i : Integer;
  t : Single;
  n : Integer;
begin
  n := Sample;

  SetLength(HammingTbl,n);
  SetLength(InvHammingTbl,n);
  
  for i:=0 to n-1 do
  begin
    t := i - n/2;
    HammingTbl[i] := 0.5 + 0.5 * cos(3.14159265*t / n);
    InvHammingTbl[i] := 1.0 / HammingTbl[i];
  end;
end;

//------------------------------------------------------------------------------
// Pzees
procedure TFFT.FFTComplex;
begin
  SubFFTComplex(FALSE);
end;

//------------------------------------------------------------------------------
// Pztees
procedure TFFT.UnFFTComplex;
begin
  SubFFTComplex(TRUE);
end;

//------------------------------------------------------------------------------
// Pzees
procedure TFFT.SubFFTComplex(decode: Boolean);
begin

end;

//------------------------------------------------------------------------------
// ၨ Ƃg̗ ၨ ɕϊ
procedure TFFT.SortFFT;
var
  i,n    : Integer;
begin
  n := SAMPLE;
  CopyMemory(@tre[0],@re[0],n*sizeof(Single));
  CopyMemory(@tre[0],@re[0],n*sizeof(Single));
  for i:=0 to n div 2 - 1 do
  begin
    re[i*2+0] := tre[i];
    re[i*2+1] := tre[n-i-1];
    im[i*2+0] := tim[i];
    im[i*2+1] := tim[n-i-1];
  end;
end;

//------------------------------------------------------------------------------
// ၨ Ƃg̗ ၨ ɕϊ
procedure TFFT.UnSortFFT;
var
  i,n    : Integer;
begin
  n := SAMPLE;
  CopyMemory(@tre[0],@re[0],n*sizeof(Single));
  CopyMemory(@tre[0],@re[0],n*sizeof(Single));
  for i:=0 to n div 2 - 1 do
  begin
    re[i]     := tre[i*2];
    re[n-i-1] := tre[i*2+1];       
    im[i]     := tim[i*2];
    im[n-i-1] := tim[i*2+1];
  end;
end;

//------------------------------------------------------------------------------
// SmallInt͈̔͂ɃT`G[V
procedure TFFT.SatSmallInt;
var
  i,n    : Integer;
begin
  n := SAMPLE;
  for i:=0 to n-1 do
  begin
    if (re[i] > +32767)then re[i] := +32767;
    if (re[i] < -32767)then re[i] := -32767;
    if (im[i] > +32767)then im[i] := +32767;
    if (im[i] < -32767)then im[i] := -32767;
  end;
end;

//------------------------------------------------------------------------------
// Ke[u쐬
procedure TFFT.MakeNormalizeTbl;
var
  n,i,h : Integer;
begin
  n := Sample;
  h := Sample div 2;
  SetLength(NormTbl,n);

  //g̍}āA
  //l͌olłāAmȌɂ̂Ƃ̂ł͂ȂB
  //܂Ag1/8炢͐mȒlł͂Ȃ̂Ō
  for i:=0 to h - 1 do
  begin
    NormTbl[i] := power(i/h,0.85);
    NormTbl[i] := NormTbl[i] + 0.025*(1.0-NormTbl[i]);
    NormTbl[i] := NormTbl[i]/150;
    //NormTbl[i] := (1.1-sin((90+i*90/h)*3.141592/180))/500;
    //NormTbl[n div 2 -i-1] := (1 / (i+1))/200;
  end;
  for i:=0 to h-1 do
    NormTbl[n-i-1] := NormTbl[i];
end;

//------------------------------------------------------------------------------
// g1.0ڈɂȂ悤ɐK
procedure TFFT.NormalizeFFT;
var
  n,i : Integer;
begin
  n := Sample;

  for i:=0 to n - 1 do
  begin
    re[i]    := re[i]     * NormTbl[i];
    im[i]    := im[i]     * NormTbl[i];
  end;
end;

end.
