//
//      OggVorbis Library iKvȂ̂ˁj
//      Coder : Ko-Ta

// Fixed Date
//      2003.08/20      Master/ChannelVolumeOggdataɊǗč
//      2003.02/07      [vEtF[hoOC
//      2003.01/20      Load֐̓ꉻ
//      2003.01/19      Offset̕ԂlԈĂi
//      2003.01/17      ȂƂg郌xɂȂ恄EQ
//      2003.01/15      EQ@\Ă݂mCYEE
//      2003.01/13      FFTɂg@\
//      2003.01/11      GetOutputSumASỶ
//      2003.01/10      ̈ʕیG[΍
//      2003.01/09      A^Cʎ擾@\
//      2003.01/08      Volume.Rendering.Loop@\
//      2003.01/06      KvȊ֐wb_甲o
//      2002.12/29      \̂̋ڂBYTEDWORDɕύXi{ŃVJV
//      2002.12/28      CallBackFunction̐錾stdcallcdeclɕύX
//      2002.12/21      Ƃ肠NXĂ݂
//      2003.17/07      ggDLLł쐬Jn(DLLt@C͕ʂɂ)

unit OggDataLib;

interface

uses Windows, SysUtils, Classes, FFTLib, math, OggWuvorbisLib,mmsystem;

//==============================================================================
// 萔
const _SEEKZERO = 0.000;
const OGG_FFTSAMPLE = 256;
const _WHITESKIPTIME = 0.2;

//Đ
type TPLAYSTATE = (psNONE,psSTOP,psPLAY,psLOOP);

// EQtF[h\
type TOggEQ = record
  sNow : Single;
  sSet : Single;
  sAdd : Single;
end;
// ʃtF[h\
type TOggVolume = record
  iNow : Integer;
  iSet : Integer;
  iAdd : Integer;
end;

// Waveg`ꊇǂݍݗp
type TLRWavePack = record
  L : SmallInt;
  R : SmallInt;
end;
type PLRWavePack = ^TLRWavePack;
// OggVorbis[v\
type TOggLoop = packed record
  BeginTime : Single;   
  EndTime   : Single;
  Count     : Integer;
end;
// OggHeadder
type TAlphaOggHed = packed record
  Hed : array[0..7]  of char;
  Loop: array[0..15] of TOggLoop;
end;

// OggVorvisǗNX
type TOggData = class
  private

  protected
    // Ǘp
    FThreadList : TThreadList;
    FLoaded       : Boolean;
    FOggStream    : TMemoryStream;
    FOggOffset    : Int64;
    FOggVorbisFile: wu_OggVorbis_File;
    FLoopFlag     : Boolean;        //[vĐĂ邩H
    FPlayFlag     : Boolean;        //ĐĂ邩H
    FWaveBuffer   : TMemoryStream;  //RenderingBuffer
    FWaveBufferPos: DWORD;          //RenderingPos
    FLastRendTime : Int64;          //ŌRenderingꂽԂێ
    FLoopCount    : array[0..15] of Integer;   //[vJEg
    FTempBuf      : array[0..2047] of SmallInt;
    //FPreTimeTell  : Single;
    FPrePlayState : TPLAYSTATE;
    FOggMemoryStream : TmemoryStream;

    FVolume       : TOggVolume;
    FMasterVolume : Integer;
    FChannelVolume: Integer;
                                //CRCUp
    PreRWave : array[0..OGG_FFTSAMPLE div 1 -1] of Single;
    PreLWave : array[0..OGG_FFTSAMPLE div 1 -1] of Single;

    PreNoiseRWave,PreNoiseLWave : Integer; //mCYp

    FEQ : array[0..255] of TOggEQ;   //EQ

    procedure OggThreadLock;
    procedure OggThreadUnLock;
    function _RenderingToPointer(ptr:Pointer; llen:Integer):Integer;
    function _ReadWaveFormat(dptr:Pointer; ReadLen:Integer):Integer;
    procedure   LPPCharToStringList(sl:TStringList; p:LPPChar);
    procedure   GetOggInfo;
    procedure   ApplyEQ(d:Pointer; Len:Integer);
    function    Harmite2(const x:array of Single; xx: Single; n: Integer): Single;
    function    Hermite( p0, p1, p2, p3, aRate: Single; tr1: Single = 1.0; tr2: Single = 1.0 ): Single;
  public
    Channels   : Integer;
    Rate       : Integer;
    Vendor     : String;
    UserComment: TStringList;
    TotalTime  : Single;
    TotalSize  : Int64;

    // [v
    LoopData   : array[0..15] of TOggLoop;

    // FFT Class
    FFT1,FFT2 :TFFT;

    // GtFNgW
    EffectValue : array[0..15] of Single;

    constructor Create(Len:Integer);
    destructor  Destroy; override;

    //
    procedure   Init;
    //t@Cǂݍ
    function    LoadLoop(ss:TMemoryStream):Boolean;
    function    LoadOgg(ss:TMemoryStream):Boolean; overload;
    function    LoadOgg(Filename:String):Boolean; overload;
    function    LoadOgg2(ss:TStream):Boolean; overload;
    function    SaveAlphaOgg(Filename:String):Boolean;
    //Waveg`_O
    function    RenderingToPointer(d:Pointer; Len:Integer):Integer;
    function    Rendering:Integer;
    //V[N
    function    TimeTell:Single;
    procedure   TimeSeek(t:Single);
    function    SeekAble:Boolean;
    //ĐE~
    procedure   Play(Loop:Boolean);
    procedure   Stop;
    procedure   Pause;
    //ʑ
    procedure   SetVolume(v:Single); overload;
    procedure   SetVolume(v,t:Single); overload;
    procedure   SetMasterVolume(v:Single);
    procedure   SetChannelVolume(v:Single);
    function    GetNowVolume:Single;   //݂̉
    function    GetSetVolume:Single;   //ڕW̉
    function    GetMasterVolume:Single;
    function    GetChannelVolume:Single;
    //EQ
    procedure   SetEQ(h:Integer; v:Single); overload;
    procedure   SetEQ(h:Integer; v,t:Single); overload;
    function    GetNowEQ(h:Integer):Single;
    function    GetSetEQ(h:Integer):Single;
    function    GetEQ:Boolean;
    procedure   SetEQ16(v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16, t : Single);
    procedure   SetEQ8(v1,v2,v3,v4,v5,v6,v7,v8, t:Single);
    procedure   SetEQ4(v1,v2,v3,v4, t:Single);
    //[v
    function    GetLoopCount(n:Integer):Integer;
    procedure   SetLoopCount(n,l:Integer);
    //ԃXLbv
    procedure   WhiteSkip(v:Integer);
    //A^CWaveVolume擾i덷j
    function    GetOutputWavePos: Integer;
    function    GetOutputSum:Single; overload;
    function    GetOutputSum(c:Integer):Single; overload;
    procedure   GetOutputGraph(d:PSingle);
    function    GetOutputTime:Single;
    //ԃtO
    function    GetPlayState : TPLAYSTATE;
    function    GetNowPlayState : TPLAYSTATE;
    //
    function    Memory  : Pointer;  //Waveg`i[|C^
    function    Offset  : Pointer;  //_OWaveg`̐擪AhX
end;

function OggToMemoryStream(ss:TStream):TMemoryStream; overload;
function OggToMemoryStream(filename:String):TMemoryStream; overload;

implementation

//------------------------------------------------------------------------------
// Oggf[^Waveg`ɕϊ
function OggToMemoryStream(ss:TStream):TMemoryStream; overload;
  procedure _ClearWaveBuffer(ss:TmemoryStream);
  var
    i : Integer;
    p : PSmallInt;
  begin
    p := ss.Memory;
    for i:=0 to (ss.Size div 2)-1 do
    begin
      p^ := 0;
      inc(p);
    end;
  end;
var
  OggData : TOggData;
  ss2,Buf : TMemoryStream;
  Len     : DWORD;
begin
  RESULT := NIL;
  //O
  if (ss = nil)then exit;
  // OggDataǂݍ܂
  ss.Position := 0;
  ss2 := TMemoryStream.Create;
  ss2.CopyFrom(ss,0);
  ss2.Position := 0;
  OggData := TOggData.Create(44100);
  OggData.LoadOgg(ss2);              //ss2͋zB
  OggData.SetVolume(1.0);
  OggData.Play(FALSE);
  Len := OggData.TotalSize;
  //ꍇ͂ƒ߂
  if (Len < 1024*32)then Len := 1024*32;
  if (Len mod 1024 <> 0)then Len := Len + (1024 - (Len mod 1024));
  // WJpobt@̐
  Buf := TMemoryStream.Create;
  Buf.SetSize(Len);
  _ClearWaveBuffer(Buf);
  OggData.RenderingToPointer(Buf.Memory,OggData.TotalSize);
  //J
  OggData.Free;

  RESULT := Buf;
end;

function OggToMemoryStream(filename:String):TMemoryStream; overload;
var
  ss : TMemoryStream;
begin
  ss := TMemoryStream.Create;
  ss.LoadFromFile(filename);
  RESULT := OggTomemoryStream(ss);
  ss.Free;
end;


{ TOggDecoder }
//------------------------------------------------------------------------------
// 
constructor TOggData.Create(Len:Integer);
var
  i   : Integer;
begin
  inherited Create;     //ӖȂ̂͂킩Ă܂i

  FThreadList := TThreadList.Create;

  // UserComment
  UserComment := TStringList.Create;

  // FFT Class ̐
  FFT1 := TFFT.Create(OGG_FFTSAMPLE);
  FFT2 := TFFT.Create(OGG_FFTSAMPLE);

  // Waveg`ۑp
  FWaveBuffer := TMemoryStream.Create;
  FWaveBuffer.SetSize(Len);           //Xg[~Oobt@

  //GtFNgpۑg`obt@
  for i:=0 to OGG_FFTSAMPLE div 4 - 1 do
  begin
    PreRWave[i] := 0.0;
    PreLWave[i] := 0.0;
  end;

  // ꂢɂƂ
  Init;

  // EQݒ
  for i:=0 to 255 do SetEQ(i,1.0);

  // ʐݒ
  SetVolume(1.0);
  SetMasterVolume(1.0);
  SetChannelVolume(1.0);
end;

//------------------------------------------------------------------------------
// 
destructor TOggData.Destroy;
begin
  // LCL
  Init;

  // Waveg`ێ̈̊J
  FWaveBuffer.Free;

  // UserComment
  if (UserComment <> nil)then UserComment.Free;

  // DSL Class ̉
  FFT1.Free;
  FFT2.Free;

  FThreadList.Free;
  
  inherited Destroy;
end;

//------------------------------------------------------------------------------
// ꂢς
procedure TOggData.Init;
begin
  // Đ~
  Pause;

  // OggXe[^X
  UserComment.Clear;
  Vendor   := '';
  Channels := 0;
  Rate     := 0;
  TotalTime:= 0.0;
  TotalSize:= 0;

  //^C~O҂
  OggThreadLock;

  try
    // Oggkf[^
    if (FOggStream <> nil)then
    begin
      _VorbisfileDll.wu_ov_clear(FOggVorbisFile);   //OggData.Free͏Ɏsidl
      FOggStream := nil;
    end;

    //̈̏
    Zeromemory(FWaveBuffer.Memory,FWaveBuffer.Size);

    // VorbisFilef[^
    ZeroMemory(@FOggVorbisFile,sizeof(wu_OggVorbis_File));
  except
  end;

  OggThreadUnLock;
  //Sleep(25);
end;

//------------------------------------------------------------------------------
// ǂݍ(FileName & TMemoryStream)
function TOggData.LoadOgg(Filename: String): Boolean;
var
  ms : TMemoryStream;
begin
  Result := FALSE;
  if (FileExists(Filename)=FALSE)then exit;
  ms := TMemoryStream.Create;
  ms.LoadFromFile(Filename);
  ms.Position := 0;
  Result := LoadOgg(ms);
end;

function TOggData.LoadOgg(ss: TMemoryStream): Boolean;
begin
  RESULT := FALSE;
  if (ss = nil)then exit;
  //Yɂ
  Init;
  //wb_ǂݍ
  LoadLoop(ss);
  //Xg[Ⴄ
  FOggStream := ss;
  FOggOffset := ss.Position;
  if (_VorbisfileDll.wu_ov_open_callbacks(Pointer(FOggStream),FOggVorbisFile,nil,0) < 0)then
  begin
    if (FOggStream <> nil)then FOggStream.Free;
    FOggStream := nil;
    raise ERangeError.CreateFmt('t@C̓ǂݍ݂Ɏs',[]);
    exit;
  end;
  //
  GetOggInfo;

  //Sleep(25);

  //[htOTRUEɃZbg
  FLoaded := TRUE;

  Result := TRUE;
end;



//------------------------------------------------------------------------------
// OggFilȅ
procedure TOggData.GetOggInfo;
var
  FPComment : LPwu_vorbis_comment;
  FPInfo    : LPwu_vorbis_info;
begin
  FPComment := LPwu_vorbis_comment(_VorbisfileDll.wu_ov_comment(FOggVorbisFile,-1));
  FPInfo    := LPwu_vorbis_info(_VorbisfileDll.wu_ov_info(FOggVorbisFile,-1));

  Vendor     := FPComment.vendor;
  LPPCharToStringList(UserComment,FPComment.user_comments);
  Channels   := FPInfo.channels;
  Rate       := FPInfo.rate;
  TotalTime  := _VorbisfileDll.wu_ov_time_total(FOggVorbisFile,-1);
  ToTalSize  := _VorbisfileDll.wu_ov_pcm_total(FOggVorbisFile,-1) *2*2;
end;

//------------------------------------------------------------------------------
//LPPCharStringList֕ϊ
procedure TOggData.LPPCharToStringList(sl:TStringList; p: LPPChar);
var
  pp: LPPChar;
  s : String;
begin
  pp:= p;
  while (PChar(pp^) <> nil)do
  begin
    s := pchar(pp^);
    s := Utf8ToAnsi(s);
    sl.Add(s);
    inc(pp);
  end;
end;

//------------------------------------------------------------------------------
// Waveg`
function TOggData.RenderingToPointer(d:Pointer; Len: Integer):Integer;
var
  SLR : PLRWavePack;
  i   : Integer;
  NowTime : Single;
  aaa : Integer;
  dd  : PCHAR;
  FVol,MVol: Integer;
  ll,rr : Integer;
begin
  result := 0;

  FPrePlayState := GetPlayState;

  //ʂODOȂ~Ă܂܂傤
  if ((GetNowVolume<0.01)and(GetSetVolume<0.01))then Pause;
  //ǂݍ܂ĂȂꍇ
  //t~Ԃ̏ꍇ
  //~[gԁiFNowVolume = 0)̏ꍇ
  if ((FLoaded = FALSE)or(FPlayFlag=FALSE)) then
  begin
    ZeroMemory(d,Len);
    result := 0;
    exit;
  end;

  //_O߂ꂽԂ擾
  FLastRendTime := TimeGetTime;

  //i̊֐ɂ銄荞݂sɂj
  OggThreadLock;

  try
    //[vp
    NowTime := _VorbisfileDll.wu_ov_time_tell(FOggVorbisFile);
    dd      := d;
    for i:=0 to 15 do
    begin
      //[vI_(EndTime)ɒBǂH
      if (LoopData[i].EndTime >= NowTime)then
        if (LoopData[i].EndTime <= (NowTime+Len/176400))then
          if ((LoopData[i].Count>FLoopCount[i])or(LoopData[i].Count=-1))then
          begin
            if (LoopData[i].Count<>-1)then inc(FLoopCount[i]);                                  //JEgCNg
            aaa := Round((LoopData[i].EndTime - NowTime)*176400) and $FFFFFFFC;  //4BYTEACgɂ킹
            Result := _RenderingToPointer(dd,aaa);             //EndTime܂Ń_O
            inc(dd,aaa);                                         //]|C^i߂
            _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,LoopData[i].BeginTime);  //BeginTime܂ŃV[N
            Result := Result + _RenderingToPointer(dd,Len-aaa);//c_O
          end;
       //[vn_茻݈ʒuOȂ΃JEgZbg
       if (Loopdata[i].EndTime < NowTime)then FLoopCount[i] := 0;
    end;

    if (dd = d)then result := _RenderingToPointer(d,Len); //[vɊYȂ烌_O

    //EQ
    ApplyEQ(d,Len);

    //ʂ𔽉f
    SLR := d;
    MVol:= FMasterVolume * FChannelVolume div 256;
    for i:=0 to (Len div 4)-1 do
    with FVolume do
    begin
      if (iAdd <> 0)then
      begin
        if (abs(iSet - iNow) < abs(iAdd))then
        begin
          iNow := iSet;
          iAdd := 0;
        end;
        iNow := iNow + iAdd;
      end;
      FVol := (iNow div $2B1100) * MVol div 256;   //$2B1100 = 128*44100 = (x)x(Hz)
      ll :=  Integer(SLR^.L) * FVol div 256;
      rr :=  Integer(SLR^.R) * FVol div 256;
      if (FVol > 255)then
      begin
        if (ll<-$7FFE)then ll := -$7FFE;
        if (ll>$7FFE )then ll := $7FFE;
        if (rr<-$7FFE)then rr := -$7FFE;
        if (rr>$7FFE )then rr := $7FFE;
      end;
      SLR^.L:= SmallInt(ll);
      SLR^.R:= SmallInt(rr);
      inc(SLR);
    end;
  except
  end;
  
  //tO
  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ݂̎Ԃ擾
function TOggData.TimeTell: Single;
begin
  if (FOggStream = nil)then
    result := 0.0
  else
    result := _VorbisfileDll.wu_ov_time_tell(FOggVorbisFile);
end;

//------------------------------------------------------------------------------
// ĐJn
procedure TOggData.Play(Loop:Boolean);
begin
  FPlayFlag := TRUE;
  FLoopFlag := Loop;
  //OiT T
  //Volume0.0ɃZbgčĐꍇ
  //if (GetPlayState<psPLAY)then
  //  if (GetSetVolume < 0.001)then SetVolume(1.0);
end;

//------------------------------------------------------------------------------
// ~
procedure TOggData.Stop;
var
  i : Integer;
begin
  Pause;

  TimeSeek(0.0);

  for i:=0 to 15 do
    FLoopCount[i] := 0;

  ZeroMemory(FWaveBuffer.Memory,FWaveBuffer.Size);
end;

//------------------------------------------------------------------------------
// w莞ԂɃWv
procedure TOggData.TimeSeek(t: Single);
var
  tt : Single;
begin
  if (FLoaded = FALSE)then exit;

  //if (FOggVorbisFile.ready_state <> 4)then exit;
  tt := t;
  if (tt < _SEEKZERO)then tt := _SEEKZERO;
  if (tt > TotalTime)then tt := TotalTime;
  if (abs(TimeTell-tt)<_SEEKZERO)then exit;

  if (SeekAble)then
  begin

    OggThreadLock;

    try
      _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,tt);
    except
    end;

    OggThreadUnLock;

    //Sleep(25);
  end;

end;

//------------------------------------------------------------------------------
// ʃRg[
procedure TOggData.SetVolume(v: Single);
begin
  SetVolume(v,0);
end;

procedure TOggData.SetVolume(v, t: Single);
var
  vv : Single;
begin
  vv := v;
  if (vv < 0.0)then vv := 0.0;
  if (vv > 2.0)then vv := 2.0;

  with FVolume do
    if (t < 0.01)then
    begin
      //ɉʂ𔽉f
      iNow := Trunc(vv*$2B110000);
      iSet := iNow;
      iAdd := 0;
    end
    else
    begin
      //tF[h
      iSet := Trunc(vv*$2B110000);
      iAdd := Trunc((iSet-iNow)/(t*44100));
    end;
end;

//------------------------------------------------------------------------------
// ݂̉ʂԂ
function TOggData.GetNowVolume: Single;
begin
  result := FVolume.iNow / $2B110000;
end;

//------------------------------------------------------------------------------
// ݒ肵ʂԂ
function TOggData.GetSetVolume: Single;
begin
  result := FVolume.iSet / $2B110000;
end;

//------------------------------------------------------------------------------
// [v擾
function TOggData.GetLoopCount(n: Integer): Integer;
begin
  result := 0;
  if (n > 15)then
    exit
  else
    result := FLoopCount[n];
end;

//------------------------------------------------------------------------------
// [vvOύX
procedure TOggData.SetLoopCount(n, l: Integer);
begin
  if (n > 15)then
    exit
  else
    FLoopCount[n] := l;
end;

//------------------------------------------------------------------------------
//ݏo͂Ă鉹ʂԂ
function TOggData.GetOutputSum: Single;
begin
  result := GetOutputSum(2);
end;

//`lw肵Ď擾B
//ch ... 0.Left / 1.Right / 2.Both
function TOggData.GetOutputSum(c: Integer): Single;
var
  WavPos    : DWORD;
  SLR       : PLRWavePack;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  LVol,RVol : Integer;
begin
  result := 0;
  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBuffer.Size;
  BufMem  := DWORD(FWaveBuffer.Memory);
  p       := GetOutputWavePos;   //ĐBuffer̈ʒu擾
  if (p = -1)then exit;
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  LVol  := 0;
  RVol  := 0;
  for i:=0 to 255 do        //256
  begin
    WavPos:= WavPos mod BufSize;
    SLR   := Pointer(BufMem + WavPos);
    LVol  := LVol + abs(SLR.L);
    RVol  := RVol + abs(SLR.R);
    inc(WavPos,4);
  end;

  LVol := LVol div 256;
  RVol := RVol div 256;

  case c of
    0   : result := LVol / 32768;
    1   : result := RVol / 32768;
    else  result := (LVol+RVol) / 65536;
  end;

end;

//------------------------------------------------------------------------------
// O_ÖiMemoryjɏo͂
function TOggData.Rendering:Integer;
var
  len : Integer;
  ptr : PCHAR;
begin
  len := FWaveBuffer.Size div 2;

  if (FWaveBufferPos = 0)then FWaveBufferPos := len
                         else FWaveBufferPos := 0;
  ptr := Offset;
  
  result := RenderingToPointer(ptr,len);
end;

//------------------------------------------------------------------------------
// Waveg`ێp̈̃ԂԂ
function TOggData.Memory: Pointer;
begin
  result := FWaveBuffer.Memory;
end;

//------------------------------------------------------------------------------
// ŌRendering̊JnʒuԂ
function TOggData.Offset: Pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory) + FWaveBufferPos);
end;

//------------------------------------------------------------------------------
// [vwb_̓ǂݍ
function TOggData.LoadLoop(ss: TMemoryStream): Boolean;
var
  hed : TAlphaOggHed;
  i   : Integer;
  pos : Int64;
  hc  : array[0..8] of char;
begin
  result := FALSE;
  if (ss = nil)then exit;
  if (ss.Size < Sizeof(TAlphaOggHed))then exit;

  //wb_F
  pos := ss.Position;
  ZeroMemory(@hc,9);
  ss.Read(hc,8);
  ss.Position := pos;
  if (hc <> 'ALPHAOGG')then exit;

  //wb_ǂݍ
  ss.Read(hed,Sizeof(TAlphaOggHed));
  for i:=0 to 15 do
    move(hed.Loop[i],LoopData[i],Sizeof(TOggLoop));
  result := TRUE;
end;

//------------------------------------------------------------------------------
// AlphaOggƂăt@Cɕۑ
function TOggData.SaveAlphaOgg(Filename: String): Boolean;
var
  fs : TFileStream;
  Hed: TAlphaOggHed;
  i  : Integer;
  Len: Integer;
  Ptr: PByte;
begin
  result := FALSE;
  if (FOggStream = nil)then exit;

  fs := TFileStream.Create(Filename,fmCreate);
  // wb_̏
  Hed.Hed := 'ALPHAOGG';
  for i:=0 to 15 do
    move(LoopData[i],Hed.Loop[i],sizeof(TOggLoop));
  fs.Write(Hed,Sizeof(TAlphaOggHed));
  //Oggt@C
  Len := FOggStream.Size - FOggOffset;
  Ptr := Pointer(DWORD(FOggStream.Memory)+FOggOffset);
  fs.Write(Ptr^,Len);
  fs.Free;

  result := TRUE;
end;

//------------------------------------------------------------------------------
// GtFNgiCRCUj
procedure TOggData.ApplyEQ(d: Pointer; Len: Integer);

  procedure SubApplyEQ(dd:Pointer; ll:Integer);
  var
    SLR,ALR : PLRWavePack;
    lll     : Integer; //c
    wl      : Integer; //Waveǂݍޒ
    n       : Integer; //FFT̒
    n4      : Integer; //n/4
    iii     : Integer;
    dpos,tpos : Integer;
    EQValue : array[0..255] of Single;
  begin
    //TvOiFFT̊֌Wセɏ]j
    n := OGG_FFTSAMPLE;
    n4:= n div 4;
    //OGG_FFTSAMPLEɕăGtFNgĂ
    //  Ƃf[^FFTɓnAԊҌA̕Kp
    // ..O񃌃_O
    // ..Waveǂݍ݁Aۂɔf镔
    // ..WaveǂݍނAvZɂ邾Ŏۂɂ͔fȂ
    SLR := d;
    lll := ll div 4;       //ratePʂɕϊ
    while (lll > 0)do
    begin
      ALR := SLR;
      wl  := Min(lll,n4*3);          //̒
      dpos:= n4;                     //̊Jnʒu
      if (wl < n4*3)then tpos := dpos + wl - n4//Ɏg遡̊Jnʒu
                    else tpos := n4*2;
      // EQ̃tF[hݒ
      for iii:=0 to 255 do
      begin
        with FEQ[iii] do
        begin
          if (abs(sNow-sSet)<abs(sAdd*wl))then
          begin
            sNow := sSet;
            sAdd := 0.0;
          end
          else
          begin
            sNow := sNow + sAdd * wl;
          end;
          if (iii and 1 = 0)then EQValue[iii div 2]    := sNow
                            else EQValue[255-iii div 2]:= sNow;
        end;
      end;
      // Zbg
      for iii:=0 to n4 - 1 do
      begin
        FFT1.re[iii] := PreLWave[iii];
        FFT1.im[iii] := PreRWave[iii];
      end;
      // Zbg
      SLR := ALR;
      for iii:=0 to wl-1 do
      begin
        FFT1.re[iii+dpos] := SLR^.L;
        FFT1.im[iii+dpos] := SLR^.R;
        inc(SLR);
      end;
      // f钷(n4*2)𖞂ĂȂꍇ́A
      // mCY΍ƂďI܂œg`Ŗ߂
      dec(SLR);  //ŏIʒuɖ߂
      for iii:=wl to n4*3-1 do
      begin
        FFT1.re[iii+dpos] := SLR^.L;
        FFT1.im[iii+dpos] := SLR^.R;
      end;
      // PreWaveobt@Ɋi[
      for iii:=0 to n4 - 1 do
      begin
        PreLWave[iii] := FFT1.re[iii+tpos];
        PreRWave[iii] := FFT1.im[iii+tpos];
      end;
      // GtFNgKp
      FFT1.HammingWindow;   //n~O
      FFT1.FFT;             //g
      for iii:=0 to n - 1 do
      begin
        FFT1.re[iii]  := FFT1.re[iii] * EQValue[iii];
        FFT1.im[iii]  := FFT1.im[iii] * EQValue[iii];
      end;
      FFT1.UnFFT;           //tg
      FFT1.UnHammingWindow; //n~OɂČg`ɖ߂
      FFT1.SatSmallInt;     //Oa
      // ۂɔf(n4*2)𖞂Ă邩H
      if (wl < n4*3)then
      begin
        // ĂȂꍇ͑S
        SLR := ALR;
        for iii:=0 to wl-1 do
        begin
          SLR^.L := Round(FFT1.re[iii+dpos]);
          SLR^.R := Round(FFT1.im[iii+dpos]);
          inc(SLR);
        end;
        lll := lll - wl;     //c炷
      end
      else
      begin
        // Ă̂n4*2f
        SLR := ALR;
        for iii:=0 to n4*2 - 1 do
        begin
          SLR^.L := Round(FFT1.re[iii+dpos]);
          SLR^.R := Round(FFT1.im[iii+dpos]);
          inc(SLR);
        end;
        lll := lll - n4*2; //c炷
      end;

    end;
  end;

  procedure SubApplyNoiseCut(dd:Pointer; ll:Integer);
  var
    SLR : PLRWavePack;
    i   : Integer;
  begin
    // gɒ[ɘMƁA傫ȍv`v`mCYꍇ
    // ̂ł
    SLR := d;
    for i:=0 to ll div 4 - 1 do
    begin
      if (abs(SLR^.L - PreNoiseLWave) > 25000)then
        SLR^.L := (Integer(SLR^.L) + PreNoiseLWave * 3) div 4;
      if (abs(SLR^.R - PreNoiseRWave) > 25000)then
        SLR^.R := (Integer(SLR^.R) + PreNoiseRWave * 3) div 4;

      PreNoiseLWave := SLR^.L;
      PreNoiseRWave := SLR^.R;
      inc(SLR);
    end;;
  end;
begin
  if (GetEQ)then SubApplyEQ(d,Len);
end;

//------------------------------------------------------------------------------
// gʂԂ
procedure TOggData.GetOutputGraph(d:PSingle);
var
  WavPos    : DWORD;
  sPtr      : PSingle;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  t         : Single;
  SLR       : PLRWavePack;
begin
  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBuffer.Size;
  BufMem  := DWORD(FWaveBuffer.Memory);
  p       := GetOutputWavePos;      //ĐBuffer̈ʒu擾
  if (p = -1)then
  begin
    sPtr := d;
    for i:=0 to 255 do
    begin
      sPtr^ := 0.0;
      inc(sPtr);
    end;
    exit;
  end;
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  for i:=0 to 255 do        //256
  begin
    WavPos:= WavPos mod BufSize;
    SLR   := Pointer(BufMem + WavPos);
    FFT2.re[i] := SLR^.L;
    FFT2.im[i] := SLR^.R;
    inc(WavPos,4);
  end;

  FFT2.HammingWindow;
  FFT2.FFT;
  FFT2.NormalizeFFT;   //g̃m[}CY

  // gggƕ̂ŁAggɕёւďo
  // āASinC
  sPtr := d;
  for i:=0 to 127 do
  begin
    t := (abs(FFT2.re[i])+abs(FFT2.im[i]))/2;
    sPtr^ := t;
    inc(sPtr);
    t := (abs(FFT2.re[255-i])+abs(FFT2.im[255-i]))/2;
    sPtr^ := t;
    inc(sPtr);
  end;
end;

//------------------------------------------------------------------------------
// ݃A^CōĐĂWaveBuffer̈ʒuԂ
// WaveBuffer̐擪AhX牽BYTEڂ\̂łāAAhXł͂ȂB
// obt@ɂȂꍇ-1Ԃ
function TOggData.GetOutputWavePos: Integer;
var
  BufSize : Integer;
  TimePos : Single;
  WavPos  : Integer;
begin
  result := -1;
  //WaveBuffer̃TCY
  BufSize := FWaveBuffer.Size;
  //BYTEi񂾂Zo
  TimePos:= (TimeGetTime - FLastRendTime)/1000; // i񂾎ԂZo
  if (TimePos > (BufSize/44100*2*2))then exit;   // Đ^Cobt@傫ꍇ
  WavPos := Round(TimePos * (44100*2*2));        // msWAVEʒuɕϊ
  WavPos := WavPos and $FFFFFFFC;                // 4BYTEACgɍ킹
  if (WavPos > BufSize)then exit;                // WaveBufferɂȂꍇ
  //FWaveBuffer̃AhX߂
  if (FWaveBufferPos = 0)then WavPos := WavPos + BufSize div 2;
  WavPos := WavPos  mod BufSize;
  result := WavPos;
end;

//------------------------------------------------------------------------------
// ݂EQVolumeԂ
function TOggData.GetNowEQ(h: Integer): Single;
begin
  result := FEQ[h].sNow;
end;

//------------------------------------------------------------------------------
// ݂EQVolumeԂ
function TOggData.GetSetEQ(h: Integer): Single;
begin
  Result := FEQ[h].sSet;
end;

//------------------------------------------------------------------------------
// EQVolumeZbg
procedure TOggData.SetEQ(h: Integer; v: Single);
begin
  SetEQ(h,v,0.0);
end;

procedure TOggData.SetEQ(h: Integer; v, t: Single);
begin
  with FEQ[h] do
  if (t < 0.001)then
  begin
    sSet := v;
    sAdd := 0.0;
    sNow := v;
  end
  else
  begin
    sSet := v;
    sAdd := (sSet - sNow) / (t*44100);
  end;
end;

//------------------------------------------------------------------------------
// ȈՃCRCUݒ
procedure TOggData.SetEQ16(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11,
  v12, v13, v14, v15, v16, t: Single);
var
  yy : array[0..15] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  yy[04] := v5;
  yy[05] := v6;
  yy[06] := v7;
  yy[07] := v8;
  yy[08] := v9;
  yy[09] := v10;
  yy[10] := v11;
  yy[11] := v12;
  yy[12] := v13;
  yy[13] := v14;
  yy[14] := v15;
  yy[15] := v16;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*15/255,16),0),t);
end;

procedure TOggData.SetEQ4(v1, v2, v3, v4, t: Single);
var
  yy : array[0..3] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*3/255,4),0),t);
end;

procedure TOggData.SetEQ8(v1, v2, v3, v4, v5, v6, v7, v8, t: Single);
var
  yy : array[0..9] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  yy[04] := v5;
  yy[05] := v6;
  yy[06] := v7;
  yy[07] := v8;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*7/255,8),0),t);
end;

//------------------------------------------------------------------------------
// G~[g
function TOggData.harmite2(const x:array of Single; xx: Single; n: Integer): Single;
var
  n1,n2,n3,n4: Integer;
  t : Single;
begin
   n2 := trunc(xx);
   t  := Frac(xx);
   n1 := n2 - 1; if (n1 < 0  )then n1 := 0;
   n3 := n2 + 1; if (n3 > n-1)then n3 := n-1;
   n4 := n2 + 2; if (n4 > n-1)then n4 := n-1;
   result := Hermite(x[n1],x[n2],x[n3],x[n4], t);
end;

//------------------------------------------------------------------------------
// G~[gȐ
function TOggData.Hermite(p0, p1, p2, p3, aRate, tr1, tr2: Single): Single;
var
  InvRate: Single;
  RateDash: Single;
  p1Dash, p2Dash: Single;
begin
  // ⊮̕⏕
  InvRate:= 1.0 - aRate;
  RateDash:= aRate - 1.0;
  // GZڐ𓾂
  p1Dash:= ( p2 - p0 ) * tr1;
  p2Dash:= ( p3 - p1 ) * tr2;
  // Aj[Vpɂ͋}̂ŏɂ߂
  if ( p1 = p2 ) then begin
    p1Dash:= p1Dash * 0.25;
    p2Dash:= p2Dash * 0.25;
  end;
  // vZ
  Result:=
    p1 *     ( RateDash * RateDash ) * ( aRate * 2.0 + 1.0 ) +
    p2 *     ( aRate * aRate ) *       ( 3.0 - aRate * 2.0 ) +
    p1Dash * ( InvRate * InvRate ) *   ( aRate ) +
    p2Dash * ( RateDash ) *            ( aRate * aRate );
end;

//------------------------------------------------------------------------------
// ĐԂԂ
function TOggData.GetPlayState: TPLAYSTATE;
begin
  if not(FLoaded)then
  begin
    RESULT := psNONE;
    exit;
  end;

  RESULT := psSTOP;

  if (FPlayFlag)then
    if (FLoopFlag)then RESULT := psLOOP
                  else RESULT := psPLAY;
end;

//------------------------------------------------------------------------------
//Đ~
procedure TOggData.Pause;
begin
  FPlayFlag := FALSE;
  FLoopFlag := FALSE;
  //FPreTimeTell := 0;
  //ZeroMemory(FWaveBuffer.Memory,FWaveBuffer.Size);
end;

//------------------------------------------------------------------------------
//ۃXs[J痬Ă鉹̍ĐԈʒuԂ
function TOggData.GetOutputTime: Single;
var
  t,a : Single;
begin
  a := FWaveBuffer.Size / 176400;  //x

  t := (TimeGetTime - FLastRendTime) / 1000;
  if (t > a)then t := a;

  t := TimeTell - a + t;
  if (t > TotalTime)then t := TotalTime;

  Result := t;
end;

//------------------------------------------------------------------------------
//Seek\ǂH
function TOggData.SeekAble: Boolean;
begin
  RESULT := FALSE;
  if (FLoaded = FALSE)then exit;
  if (_VorbisfileDll.wu_ov_seekable(FOggVorbisFile) <> 0)then RESULT := TRUE;
end;

function TOggData.GetEQ: Boolean;
var
  i : Integer;
  b : Boolean;
begin
  b := FALSE;
  for i:=0 to 255 do
    if (abs(GetNowEQ(i)-1.0)+abs(GetSetEQ(i)-1.0) > 0.01)then b := TRUE;
  RESULT := b;
end;

procedure TOggData.SetMasterVolume(v: Single);
begin
  FMasterVolume := Round(v*255);
end;

function TOggData.GetMasterVolume: Single;
begin
  RESULT := FMasterVolume / 255;
end;

function TOggData.GetChannelVolume: Single;
begin
  RESULT := FChannelVolume / 255;
end;

procedure TOggData.SetChannelVolume(v: Single);
begin
  FChannelVolume := Round(v*255);
end;

procedure TOggData.WhiteSkip(v: Integer);
var
  buf : array[0..255] of SmallInt;
  Sum : Integer;
  Len,Len2 : Integer;
  i : Integer;
  t : Single;
begin
  if not(FLoaded)then exit;

  //Stop;

  t := TimeTell;
  while(t < TotalTime)do
  begin
    //l𑪒
    Len := 256;
    while(Len>0)do
    begin
      Len2 := _RenderingToPointer(@buf[0],Len);
      if (len2 = -1)then break;
      Len := Len - Len2;
    end;
    Sum := 0;
    for i:=0 to 255 do
      Sum := Sum + abs(buf[i]);
    Sum := Sum div 256;
    if (Sum > v)then break;
    //i܂
    t := t + _WHITESKIPTIME;
    TimeSeek(t);
  end;

  if (t>TotalTime-_WHITESKIPTIME)then t := 0.0;
  t := t - _WHITESKIPTIME;
  if (t<0)then t := 0.0;
  TimeSeek(t);
end;

function TOggData._ReadWaveFormat(dptr:Pointer; ReadLen:Integer):Integer;
var
  iii   : Integer;
  wdptr : ^SmallInt;
  RLen  : Integer;
  current_section : Integer;
begin
  RESULT := -1;
  //_O钷𒲐iŏII44100Hz2ch̕ῗݏoȂpɁj
  RLen := ReadLen;
  //tH[}bgɂď𕦂
  case (Rate*10+Channels) of
    441002:  //44100Hz 2Channel
      begin
        //ϊ
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,dptr,RLen,0,2,1,current_section);
        RESULT := RLen;
      end;
    441001:  //44100Hz 1Channel
      begin
        //ŏII44100Hz2Chɕῗ݂Ȃ悤 /2 
        RLen := RLen div 2;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        for iii:=0 to RLen div 2 - 1 do    //SmallIntPʂő삷̂div2
        begin
          wdptr^ := FTempBuf[iii]; inc(wdptr);
          wdptr^ := FTempBuf[iii]; inc(wdptr);
        end;
        RESULT := RLen * 2;
      end;
    221002:
      begin
        RLen := RLen div 2;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        for iii:=0 to RLen div (2*2) - 1 do
        begin
          wdptr^ := FTempBuf[iii*2]; inc(wdptr);
          wdptr^ := FTempBuf[iii*2+1]; inc(wdptr);
          wdptr^ := FTempBuf[iii*2]; inc(wdptr);
          wdptr^ := FTempBuf[iii*2+1]; inc(wdptr);
        end;
        RESULT := RLen * 2;
      end;
    221001:
      begin
        RLen := RLen div 4;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        for iii:=0 to RLen div (2*2*2) - 1 do
        begin
          wdptr^ := FTempBuf[iii]; inc(wdptr);
          wdptr^ := FTempBuf[iii]; inc(wdptr);
          wdptr^ := FTempBuf[iii]; inc(wdptr);
          wdptr^ := FTempBuf[iii]; inc(wdptr);
        end;
        RESULT := RLen * 4;
      end;
  end;
end;

function TOggData._RenderingToPointer(ptr:Pointer; llen:Integer):Integer;
var
  ptr2 : PCHAR;
  LeftLen,ret : Integer;
begin
  //WaveɓWJ
  //w肵_OĕԂĂȂ
  //̂ŁAxRead݂āAɕă_OĂKvB
  //2048BYTE炢xɃ_O悤B
  ptr2    := ptr;
  LeftLen := llen;
  while (LeftLen > 0)do
  begin
    //_O
    ret := _ReadWaveFormat(ptr2,LeftLen);
    //\ʃG[
    if (ret < 0)then
    begin
      result := ret;
      Stop;
      exit;
    end;
    //I[m
    if (ret = 0)then
      if (FLoopFlag)then
      begin
        //[vĐ
        _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,_SEEKZERO);
      end
      else
      begin
        //~A
        FPlayFlag := FALSE;
        FLoopFlag := FALSE;
        _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,_SEEKZERO);
        ZeroMemory(ptr2,LeftLen);
        result := llen - LeftLen;
        exit;
      end;
    //_Oi܂B
    inc(ptr2,ret);
    dec(LeftLen,ret);
  end;

  result := llen - LeftLen;
end;

function TOggData.GetNowPlayState: TPLAYSTATE;
begin
  if (FPlayFlag)then
  begin
    RESULT := GetPlayState;
    exit;
  end;

  RESULT := FPrePlayState;

  {if not(FLoaded)then
  begin
    RESULT := psNONE;
    exit;
  end;

  RESULT := psStop;

  //FPreTellTime ɂނčĐȂ̂ŁÂ݂Ɣr
  if (FPlayFlag=FALSE)then
    if (abs(GetOutputTime-FPreTimeTell)>0.01)then
    begin
      if (FLoopFlag)then RESULT := psLOOP
                    else RESULT := psPLAY;
    end;

  if (FPlayFlag)then
    if (FLoopFlag)then RESULT := psLOOP
                  else RESULT := psPLAY;   }
end;

procedure TOggData.OggThreadLock;
//var
//  i : Integer;
begin
  FThreadList.LockList;

  //While(FThreadLockFlag)do;
  //FThreadLockFlag := TRUE;
end;

procedure TOggData.OggThreadUnLock;
begin
  FThreadList.UnlockList;
  //FThreadLockFlag := FALSE;
end;

function TOggData.LoadOgg2(ss: TStream): Boolean;
var
  ms : TMemoryStream;
begin
  ms := TmemoryStream.Create;
  ss.Position := 0;
  ms.LoadFromStream(ss);
  ms.Position := 0;
  RESULT := LoadOgg(ms);   //΂
end;

end.
