//
//      OggVorbis Player Library iKvȂ̂ˁj
//      Coder : Ko-Ta

// Fixed Date
//      2003.08/20      Master/ChannelVolumeOggDataɊii
//      2003.02/07      Pause`
//      2003.01/20      Đ̏Ȃ
//      2003.01/17      EQΉ
//      2003.01/11      GetOutputSumASỶ
//      2003.01/10      JnBVersion1.0


unit OggPlayerLib;

interface

uses Windows, SysUtils, Classes, OggDataLib, FFTLib, mmSystem;

//==============================================================================
//Ogg Player Class
//      OggDatao^(Load)ƁAďo͂Ă
//      Đɂ͂̃NXgƕ֗Ȃ
type TOggPlayer = class
  private

  protected
    //eOgg̉ʒp
    FChannelVolume : array of Integer;
    //_Op
    FRendering     : Boolean;
    FLastRendTime  : Int64;
    FWaveBuffer    : TMemoryStream;
    FWaveBufferPos : DWORD;
  public
    OggData   : array of TOggData;
    FFT2      : TFFT;
    MaxChannel: Integer;

    destructor  Destroy; override;
    constructor Create(Len:Integer; MaxCh:Integer=8);
    //ǂݍ
    procedure   Load(ch:Integer; o:TOggdata);
    procedure   UnLoad(ch:Integer);
    //_O
    procedure   Rendering;
    function    RenderingToPointer(d:Pointer; Len:Integer):Integer;
    //
    procedure   Init;
    //ĐE~
    procedure   Play(Loop:Boolean); overload;
    procedure   Play(ch:Integer;Loop:Boolean); overload;
    procedure   Stop(ch:Integer); overload;
    procedure   Stop; overload;
    procedure   Pause(ch:Integer);
    procedure   Swap(ch1,ch2:Integer);
    procedure   WhiteSkip(ch,v:Integer);
    //ʒ
    procedure   SetMasterVolume(v:Single); overload;      //Ŝ̉ʐݒ
    procedure   SetMasterVolume(ch : Integer; v:Single); overload;
    function    GetMasterVolume(ch:Integer):Single;
    procedure   SetChannelVolume(ch:Integer;v:Single);    //eOgg`l̉ʐݒ
    function    GetChannelVolume(ch:Integer):Single;
    procedure   SetVolume(ch:Integer;v:Single); overload; //Oggʐݒ
    procedure   SetVolume(ch:Integer;v,t:Single); overload;
    function    GetNowVolume(ch:Integer):Single;
    function    GetSetVolume(ch:Integer):Single;
    //
    procedure   TimeSeek(ch:Integer; t:Single);
    function    TimeTell(ch:Integer):Single;
    function    TotalTime(ch:Integer):Single;
    //[v
    function    GetLoopCount(ch,n:Integer):Integer;
    procedure   SetLoopCount(ch,n,l:Integer);
    //A^CWaveVolume擾i덷j
    function    GetOutputWavePos(ch:Integer):Integer;
    function    GetOutputSum(ch:Integer):Single; overload;
    function    GetOutputSum(ch,c:Integer):Single; overload;
    procedure   GetOutputGraph(ch:Integer; d:PSingle);
    function    GetOutputTime(ch:Integer):Single;
    function    GetMasterOutputWavePos:Integer;
    function    GetMasterOutputSum:Single; overload;
    function    GetMasterOutputSum(c:Integer):Single; overload;
    procedure   GetMasterOutputGraph(d:PSingle);
    //EQ
    procedure   SetEQ(ch:Integer; h:Integer; v:Single); overload;
    procedure   SetEQ(ch:Integer; h:Integer; v,t:Single); overload;
    function    GetNowEQ(ch:Integer; h:Integer):Single;
    function    GetSetEQ(ch:Integer; h:Integer):Single;
    function    GetEQ(ch:Integer):Boolean;
    procedure   SetEQ16(ch:Integer; v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16, t : Single);
    procedure   SetEQ8(ch:Integer; v1,v2,v3,v4,v5,v6,v7,v8, t:Single);
    procedure   SetEQ4(ch:Integer; v1,v2,v3,v4, t:Single);
    //ԃtO
    function    GetPlayState(ch:Integer) : TPLAYSTATE;
    function    GetNowPlayState(ch:Integer) : TPLAYSTATE;
    //
    function    Memory  : Pointer;  //Waveg`i[|C^
    function    Offset  : Pointer;  //_OWaveg`̐擪AhX
end;

implementation

//==============================================================================
{ TOggPlayer }
//------------------------------------------------------------------------------
// 
constructor TOggPlayer.Create(Len:Integer; MaxCh:Integer);
begin
  inherited Create; //疳ӖĂ΂

  //gp`lf[^ݒ肷
  MaxChannel := MaxCh;
  SetLength(OggData,MaxChannel);
  SetLength(FChannelVolume,MaxChannel);

  //WAVEg`_Opobt@
  FWaveBuffer := TmemoryStream.Create;
  FWaveBuffer.SetSize(Len);

  //ꂢꂢ
  Init;

  //t[GCϊ FFTNX̐
  FFT2 := TFFT.Create(256);
end;

//------------------------------------------------------------------------------
// j
destructor TOggPlayer.Destroy;
begin
  //ꂢꂢ
  Init;

  //Waveg`obt@̉
  FWaveBuffer.Free;

  //FFTNX
  FFT2.Free;

  inherited;
end;

//------------------------------------------------------------------------------
// e`l̏o͉ʐݒ擾
function TOggPlayer.GetChannelVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetChannelVolume;
end;

//------------------------------------------------------------------------------
// Ogǧ݂̉ʂԂ
function TOggPlayer.GetNowVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetNowVolume;
end;

//------------------------------------------------------------------------------
// Ogg̐ݒ艹ʂԂ
function TOggPlayer.GetSetVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetSetVolume;
end;

//------------------------------------------------------------------------------
// S`li鉹ʐݒ擾
function TOggPlayer.GetMasterVolume(ch:Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetMasterVolume;
end;

//------------------------------------------------------------------------------
// 
procedure TOggPlayer.Init;
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do
  begin
    OggData[i] := nil;
    SetChannelVolume(i,1.0);
  end;

  SetMasterVolume(1.0);

  ZeroMemory(FWaveBuffer.Memory,FWaveBuffer.Size);
end;

//------------------------------------------------------------------------------
// e`l̉ʂݒ
procedure TOggPlayer.SetChannelVolume(ch: Integer; v: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetChannelVolume(v);
end;

//------------------------------------------------------------------------------
// S`li鉹ʐݒ
procedure TOggPlayer.SetMasterVolume(v: Single);
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do
    if (OggData[i] <> nil)then
      OggData[i].SetMasterVolume(v);
end;

//------------------------------------------------------------------------------
// Ogg̉ʂݒ
procedure TOggPlayer.SetVolume(ch: Integer; v: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetVolume(v);
end;

procedure TOggPlayer.SetVolume(ch: Integer; v, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetVolume(v,t);
end;

//------------------------------------------------------------------------------
// w^CɃV[N
procedure TOggPlayer.TimeSeek(ch:Integer; t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].TimeSeek(t);
end;

//------------------------------------------------------------------------------
// ݂̈ʒuiĐoߎԁjԂ
function TOggPlayer.TimeTell(ch:Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].TimeTell;
end;

//------------------------------------------------------------------------------
// Ȃ̒Ԃ
function TOggPlayer.TotalTime(ch: Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].TotalTime;
end;

//------------------------------------------------------------------------------
// Đ̗L
function TOggPlayer.GetPlayState(ch: Integer): TPLAYSTATE;
begin
  result := psNONE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetPlayState;
end;

//------------------------------------------------------------------------------
// [vJEg̎擾
function TOggPlayer.GetLoopCount(ch, n: Integer): Integer;
begin
  result := 0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetLoopCount(n);
end;

//------------------------------------------------------------------------------
// [vJEg̐ݒ
procedure TOggPlayer.SetLoopCount(ch, n, l: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetLoopCount(n,l);
end;

//------------------------------------------------------------------------------
// A^CWAVEg`̍vlO`P͈̔͂ŕԂ
function TOggPlayer.GetOutputSum(ch, c: Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetOutputSum(c);
end;

function TOggPlayer.GetOutputSum(ch: Integer): Single;
begin
  result := GetOutputSum(2);
end;

//------------------------------------------------------------------------------
// Đ
procedure TOggPlayer.Play(ch: Integer; Loop: Boolean);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Play(Loop);
end;

procedure TOggPlayer.Play(Loop: Boolean);
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do
    Play(i,Loop);
end;

//------------------------------------------------------------------------------
//~
procedure TOggPlayer.Stop;
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do Stop(i);
end;

procedure TOggPlayer.Stop(ch: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Stop;
end;

//------------------------------------------------------------------------------
// OggData̓o^
procedure TOggPlayer.Load(ch: Integer; o: TOggdata);
var
  i : Integer;
begin
  // _Ȍꍇ͑ҋ@
  while (FRendering)do ;

  // o^imhkj
  if (o = nil)then
  begin
    OggData[ch] := nil;
    exit;
  end;

  //d΍
  for i:=0 to MaxChannel-1 do
    if (DWORD(OggData[i]) = DWORD(o))then UnLoad(i);

  //o^
  OggData[ch] := o;
end;

//------------------------------------------------------------------------------
// vg`_O
function TOggPlayer.RenderingToPointer(d:Pointer; Len:Integer):Integer;
var
  SLR  : array[0..7] of PLRWavePack;
  DLR  : PLRWavePack;
  Count: integer;
  i,j  : Integer;
  RVol,LVol : Integer;
begin
  //_OJnꂽԂ擾
  FLastRendTime := TimeGetTime;

  //_OtOĂ
  FRendering := TRUE;

  //Đ̂̂𒲂ׁA_O
  Count := 0;
  for i:=0 to MaxChannel-1 do
    if (OggData[i] <> nil)then
      if (OggData[i].Rendering > 0)then
      begin
        SLR[Count] := OggData[i].Offset;
        inc(Count);
      end;
  //Waveobt@Offset߂
  //ʒ߂sē
  DLR := d;
  for i:=0 to (Len div 4) -1 do
  begin
    RVol := 0;
    LVol := 0;
    for j:=0 to Count-1 do
    begin
      //Ogg̏o
      LVol := LVol + Integer(SLR[j]^.L);
      RVol := RVol + Integer(SLR[j]^.R);
      inc(SLR[j]);
    end;
    //OverFlow΍
    if (LVol > +32767)then LVol := +32767;
    if (LVol < -32767)then LVol := -32767;
    if (RVol > +32767)then RVol := +32767;
    if (RVol < -32767)then RVol := -32767;
    //obt@ɏ
    DLR^.L := SmallInt(LVol);
    DLR^.R := SmallInt(RVol);
    inc(DLR);
  end;

  //_OtOǂ
  FRendering := FALSE;

  //_OԂ
  result := len;
end;

//------------------------------------------------------------------------------
// f[^A[hinilԂނj
procedure TOggPlayer.UnLoad(ch: Integer);
begin
  Load(ch,nil);
end;

//------------------------------------------------------------------------------
// Waveobt@̐擪AhXԂ
function TOggPlayer.Memory: Pointer;
begin
  result := FWaveBuffer.Memory;
end;

//------------------------------------------------------------------------------
// ŌɃ_O擪AhXԂ
function TOggPlayer.Offset: Pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory)+FWaveBufferPos);
end;

//------------------------------------------------------------------------------
// Waveobt@Ƀ_O
procedure TOggPlayer.Rendering;
var
  Len : Integer;
  Ptr : PCHAR;
begin
  Len := FWaveBuffer.Size div 2;

  //OffZbgʒuvZ
  if (FWaveBufferPos = 0)then
  begin
    FWaveBufferPos := Len;
    Ptr := FWaveBuffer.Memory;
    inc(Ptr,Len);
  end
  else
  begin
    FWaveBufferPos := 0;
    Ptr := FWaveBuffer.Memory;
  end;
  
  RenderingToPointer(Ptr,Len);
end;

//------------------------------------------------------------------------------
// ŏIo͐̉ʂ̕ςA^Cŋ߂
function TOggPlayer.GetMasterOutputSum: Single;
begin
  result := GetMasterOutputSum(2);
end;

function TOggPlayer.GetMasterOutputSum(c: Integer): Single;
var
  WavPos    : DWORD;
  SLR       : PLRWavePack;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  LVol,RVol : Integer;
begin
  result := 0;
  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBuffer.Size;
  BufMem  := DWORD(FWaveBuffer.Memory);
  p       := GetMasterOutputWavePos;   //ĐBuffer̈ʒu擾
  if (p = -1)then exit;
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  LVol  := 0;
  RVol  := 0;
  for i:=0 to 255 do        //256
  begin
    WavPos:= WavPos mod BufSize;
    SLR   := Pointer(BufMem + WavPos);
    LVol  := LVol + abs(SLR.L);
    RVol  := RVol + abs(SLR.R);
    inc(WavPos,4);
  end;

  LVol := LVol div 256;
  RVol := RVol div 256;

  case c of
    0   : result := LVol / 32768;
    1   : result := RVol / 32768;
    else  result := (LVol+RVol) / 65536;
  end;

end;

//------------------------------------------------------------------------------
// ߂
procedure TOggPlayer.Pause(ch: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Pause;
end;

//------------------------------------------------------------------------------
// }X^[̌ݍĐ̈ʒuWaveBuffer̈ʒuŕԂ
// obt@ɂȂꍇ-1Ԃ
function TOggPlayer.GetMasterOutputWavePos: Integer;
var
  BufSize : Integer;
  TimePos : Single;
  WavPos  : Integer;
begin
  result := -1;
  //WaveBuffer̃TCY
  BufSize := FWaveBuffer.Size;
  //BYTEi񂾂Zo
  TimePos:= (TimeGetTime - FLastRendTime)/1000; // i񂾎ԂZo
  if (TimePos>10.0)then TimePos := 10.0;
  WavPos := Round(TimePos * (44100*2*2));        // msWAVEʒuɕϊ
  WavPos := WavPos and $FFFFFFFC;                // 4BYTEACgɍ킹
  if (WavPos > BufSize)then exit;                // WaveBufferɂȂꍇ
  //FWaveBuffer̃AhX߂
  if (FWaveBufferPos = 0)then WavPos := WavPos + BufSize div 2;
  WavPos := WavPos  mod BufSize;
  result := WavPos;
end;

function TOggPlayer.GetOutputWavePos(ch: Integer): Integer;
begin
  result := -1;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetOutputWavePos;
end;

//------------------------------------------------------------------------------
// gʂԂ
procedure TOggPlayer.GetMasterOutputGraph(d:PSingle);
var
  WavPos    : DWORD;
  sPtr      : PSingle;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  t         : Single;
  SLR       : PLRWavePack;
begin
  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBuffer.Size;
  BufMem  := DWORD(FWaveBuffer.Memory);
  p       := GetMasterOutputWavePos;      //ĐBuffer̈ʒu擾
  if (p = -1)then exit;
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  for i:=0 to 255 do        //256
  begin
    WavPos:= WavPos mod BufSize;
    SLR   := Pointer(BufMem + WavPos);
    FFT2.re[i] := SLR^.L;
    FFT2.im[i] := SLR^.R;
    inc(WavPos,4);
  end;

  FFT2.HammingWindow;
  FFT2.FFT;
  FFT2.NormalizeFFT;     //g̃m[}CY

  // gggƕ̂ŁAggɕёւďo
  // āASinC
  sPtr := d;
  for i:=0 to 127 do
  begin
    t := (abs(FFT2.re[i])+abs(FFT2.im[i]))/2;
    sPtr^ := t;
    inc(sPtr);
    t := (abs(FFT2.re[255-i])+abs(FFT2.im[255-i]))/2;
    sPtr^ := t;
    inc(sPtr);
  end;
end;


procedure TOggPlayer.GetoutputGraph(ch:Integer; d: PSingle);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].GetOutputGraph(d);
end;

//------------------------------------------------------------------------------
// ݂̃CRCU̒lԂ
function TOggPlayer.GetNowEQ(ch, h: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetNowEQ(h);
end;

//------------------------------------------------------------------------------
// ݒ肵CRCU̒lԂ
function TOggPlayer.GetSetEQ(ch, h: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := Oggdata[ch].GetNowEQ(h);
end;

//------------------------------------------------------------------------------
// CRCUɒlZbg
procedure TOggPlayer.SetEQ(ch, h: Integer; v: Single);
begin
  SetEQ(ch,h,v,0.0);
end;

procedure TOggPlayer.SetEQ(ch, h: Integer; v, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ(h,v,t);
end;

//------------------------------------------------------------------------------
// ȈՃCRCUݒ
procedure TOggPlayer.SetEQ16(ch: Integer; v1, v2, v3, v4, v5, v6, v7, v8,
  v9, v10, v11, v12, v13, v14, v15, v16, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ16(v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,t);
end;

procedure TOggPlayer.SetEQ4(ch: Integer; v1, v2, v3, v4, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ4(v1,v2,v3,v4,t);
end;

procedure TOggPlayer.SetEQ8(ch: Integer; v1, v2, v3, v4, v5, v6, v7, v8,
  t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ8(v1,v2,v3,v4,v5,v6,v7,v8,t);
end;

//------------------------------------------------------------------------------
// `l̂ւ
procedure TOggPlayer.Swap(ch1,ch2:Integer);
var
  a : TOggData;
  v : Integer;
begin
  while (FRendering) do ;

  a            := OggData[ch1];
  OggData[ch1] := OggData[ch2];
  OggData[ch2] := a;

  v := FChannelVolume[ch1];
  FChannelVolume[ch1] := FChannelVolume[ch2];
  FChannelVolume[ch2] := v;
end;

//------------------------------------------------------------------------------
//݂̃Xs[J痬Ă鎞ԂԂ
function TOggPlayer.GetOutputTime(ch: Integer): Single;
begin
  RESULT := 0.0;
  if (OggData[ch] = nil)then exit;

  RESULT := OggData[ch].GetOutputTime;
end;

function TOggPlayer.GetEQ(ch: Integer): Boolean;
begin
  result := FALSE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetEQ;
end;

procedure TOggPlayer.SetMasterVolume(ch: Integer; v: Single);
begin
  if (OggData[ch] = nil)then exit;

  OggData[ch].SetMasterVolume(v);
end;

procedure TOggPlayer.WhiteSkip(ch, v: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].WhiteSkip(v);
end;

function TOggPlayer.GetNowPlayState(ch: Integer): TPLAYSTATE;
begin
  result := psNONE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetNowPlayState;
end;

end.
